from pyroute2 import IPRoute

with IPRoute() as ipr:
    # create host dummy
    ipr.link("add",
             kind="dummy",
             ifname="qtest")
    hidx = ipr.link_lookup(ifname="qtest")[0]

    # create 802.1ad s-vlan interface (external tag)
    ipr.link("add",
             kind="vlan",
             ifname="qtest.50",
             link=hidx,
             vlan_id=50,
             vlan_protocol=0x88a8)
    sidx = ipr.link_lookup(ifname="qtest.50")[0]

    # create 802.1q c-vlan interface (internal tag)
    ipr.link("add",
             kind="vlan",
             ifname="qtest.50.120",
             link=sidx,
             vlan_id=120,
             vlan_protocol=0x8100)
    cidx = ipr.link_lookup(ifname="qtest.50.120")[0]

    # print the links
    for link in ipr.link("dump", match={"index": lambda x: x in (sidx, cidx)}):
        print(link.get_attr("IFLA_IFNAME"))
        print("\t%s" % (link.
                        get_attr("IFLA_LINKINFO").
                        get_attr("IFLA_INFO_DATA").
                        get_attr("IFLA_VLAN_PROTOCOL")))

    # clean up
    ipr.link("del", index=hidx)
